// Brick0_1bDlg.cpp:   CBrick0_1bDlg
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Brick0_1b.h"
#include "Brick0_1bDlg.h"
#include <windows.h>                      //    Windows
#include <gl\gl.h>                        //    OpenGL32 
#include <gl\glu.h>                       //    GLu32 
#include <gl\glaux.h>                     //    GLaux 
#include "brick0_1bdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

UINT BuildProc(LPVOID);
UINT RandomProc(LPVOID);
UINT StepSmallProc(LPVOID);
UINT StepBigProc(LPVOID);

// CAboutDlg -     "About..."
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CBrick0_1bDlg -    
CBrick0_1bDlg::CBrick0_1bDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBrick0_1bDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);	
}

void CBrick0_1bDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT1, editLog);
}

BEGIN_MESSAGE_MAP(CBrick0_1bDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_RIGHT, OnBnClickedRight)
	ON_BN_CLICKED(IDC_LEFT, OnBnClickedYPos)
	ON_BN_CLICKED(IDC_UP, OnBnClickedXPos)
	ON_BN_CLICKED(IDC_DOWN, OnBnClickedXNeg)

	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)

	ON_BN_CLICKED(IDC_MIXUP, OnBnClickedMixUp)
	ON_BN_CLICKED(IDC_PAUSE, OnBnClickedPause)

	ON_BN_CLICKED(IDC_STAPS_NEXT, OnNextStepBtnClick)
	ON_BN_CLICKED(IDC_STAPS_MULTINEXT, OnNextMultistepBtnClick)
	ON_BN_CLICKED(IDC_AUTO, OnBnClickedAuto)
	ON_COMMAND(ID_STAPS_NEXT, OnStapsNext)
	ON_COMMAND(ID_STAPS_MULTINEXT, OnStapsMultinext)
	ON_COMMAND(ID_STAPS_AUTO, OnStapsAuto)

	ON_COMMAND(ID_VIEW_LOGPANEL, OnViewLogPanel)

	ON_COMMAND(ID_DELAY_100MS, OnDelay100ms)
	ON_COMMAND(ID_DELAY_200MS, OnDelay200ms)
	ON_COMMAND(ID_DELAY_300MS, OnDelay300ms)
	ON_COMMAND(ID_DELAY_400MS, OnDelay400ms)
	ON_COMMAND(ID_DELAY_500MS, OnDelay500ms)

	ON_COMMAND(ID_HELP_ABOUTBRICK0, OnAbout)
END_MESSAGE_MAP()


BOOL CBrick0_1bDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	nXangle = 0;
	nYangle = 0;
	nZangle = 0;

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	pDC = GetDC();
	CenterWindow();
	InitGL();
	SetTimer(1,10, NULL);

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);

	autobr = new CAutoBrick(&br);						//   CAutoBrick
	pause = false;										//  
	step = 1;											//  
	is_first = true;									//   
	delay = 100;										//  100 .	

	CButton* btn = (CButton*)GetDlgItem(IDC_PAUSE);
	btn->SetWindowText("");
	btn = (CButton*)GetDlgItem(IDC_AUTO);
	btn->SetWindowText("");
	btn = (CButton*)GetDlgItem(IDC_MIXUP);
	btn->SetWindowText("");	
	this->SetWindowText("  v. 1.0b");

	return TRUE;
}

void CBrick0_1bDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CBrick0_1bDlg::OnPaint() 
{
	if (IsIconic())	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	} else {
		CDialog::OnPaint();
	}

	DrawScene();
}

HCURSOR CBrick0_1bDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


GLvoid CBrick0_1bDlg::InitGL()
{
	CRect rect;
	HGLRC hrc;
	if (!bSetupPixelFormat())
		return;
	hrc = wglCreateContext(pDC->GetSafeHdc());
	ASSERT(hrc != NULL);
	wglMakeCurrent(pDC->GetSafeHdc(), hrc);

	GetClientRect(&rect);
	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
	glClearDepth(1.0);
	glDepthFunc(GL_LESS);
	glEnable(GL_DEPTH_TEST);
	glShadeModel(GL_SMOOTH);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45.0f, (GLfloat)rect.right / (GLfloat)rect.bottom, 0.1f, 100.0f);
	glMatrixMode(GL_MODELVIEW);
	br.SetSize(0.8f);	
	br.Init();
}

BOOL CBrick0_1bDlg::PreCreateWindow(CREATESTRUCT& cs) 
{
	cs.style |= WS_CLIPSIBLINGS | WS_CLIPCHILDREN;
	return CDialog::PreCreateWindow(cs);
}

bool CBrick0_1bDlg::bSetupPixelFormat()
{
	static PIXELFORMATDESCRIPTOR pfd =
	{
		sizeof(PIXELFORMATDESCRIPTOR), 	//  pfd
		1, 								//  
		PFD_DRAW_TO_WINDOW | 			//  
		PFD_SUPPORT_OPENGL | 			//  OpenGL
		PFD_DOUBLEBUFFER, 				//  
		PFD_TYPE_RGBA, 					// RGBA 
		24, 							// 24-   
		0, 0, 0, 0, 0, 0,
		0,
		0,
		0,
		0, 0, 0, 0,
		32, 							// 32-  z-
		0,
		0,
		PFD_MAIN_PLANE, 				//  
		0, 								// 
		0, 0, 0
	};

	int pixelformat;

	if ((pixelformat = ChoosePixelFormat(pDC->GetSafeHdc(), &pfd)) == 0)
	{
		MessageBox("ChoosePixelFormat failed");
		return FALSE;
	}

	if (SetPixelFormat(pDC->GetSafeHdc(), pixelformat, &pfd) == FALSE)
	{
		MessageBox("SetPixelFormat failed");
		return FALSE;
	}
	return TRUE;
}

void CBrick0_1bDlg::OnTimer(UINT nIDEvent)
{
	CDialog::OnTimer(nIDEvent);
}

void CBrick0_1bDlg::DrawScene()
{
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	glTranslatef(0.0f, 0.0f, -10.0f);
	glRotatef(nXangle, 1.0f, 0.0f, 0.0f);
	glRotatef(nYangle, 0.0f, 1.0f, 0.0f);
	glRotatef(nZangle, 0.0f, 0.0f, 1.0f);
	
	br.Draw();
	glFinish();
	SwapBuffers(wglGetCurrentDC());
}

void CBrick0_1bDlg::OnBnClickedRight()
{
	nYangle -= 10;
	DrawScene();
}

void CBrick0_1bDlg::OnBnClickedYPos()
{
	nYangle += 10;
	DrawScene();
}

void CBrick0_1bDlg::OnBnClickedXPos()
{
	nXangle += 10;
	DrawScene();
}

void CBrick0_1bDlg::OnBnClickedXNeg()
{
	nXangle -= 10;
	DrawScene();
}


//    
void CBrick0_1bDlg::OnNextStepBtnClick()
/*
	 
*/
{
	if (is_first)
	{
		is_first = false;
		AddLog(1, 1);
	}
	AfxBeginThread(StepSmallProc, this);
}

void CBrick0_1bDlg::OnNextMultistepBtnClick()
/*
	 
*/
{
	if (is_first)
	{
		is_first = false;
		AddLog(1, 1);
	}
	AfxBeginThread(StepBigProc, this);
}

void CBrick0_1bDlg::OnBnClickedAuto()
/*
	 
*/
{
	if (is_first)
	{
		is_first = false;
		AddLog(1, 1);
	}
	AfxBeginThread(BuildProc, this);
}

void CBrick0_1bDlg::OnBnClickedMixUp()
/*
	
*/
{
	autobr->Reset();
	AfxBeginThread(RandomProc, this);

	is_first = true;
	step = 1;
}

void CBrick0_1bDlg::OnBnClickedPause()
/*
	
*/
{
	pause = !pause;
	CButton* btn = (CButton*)GetDlgItem(IDC_PAUSE);
	if (pause)
		btn->SetWindowText("");
	else
		btn->SetWindowText("");
}

UINT StepSmallProc(LPVOID pParam)
/*
	   
*/
{
	CBrick0_1bDlg* pObject = (CBrick0_1bDlg*)pParam;

	//  
	pObject->EnableControls(false);

	//  
	list <action> act;
	int automata = pObject->autobr->automata;

	if (!pObject->autobr->finish)
	{
		act = pObject->autobr->NextStep();

		if (!act.empty())
		{
			pObject->AddLog(2, pObject->step);

			for (list <action> :: iterator i = act.begin(); i != act.end(); i++)
			{
				pObject->br.Rotate(i->side, i->direct);
				pObject->AddLog(i->side, i->direct);
				pObject->Invalidate(0);
				Sleep(pObject->delay);
			}
	
			pObject->step++;
			pObject->AddLog("\r\n");
		}

		if (pObject->autobr->automata != automata)
		{
			pObject->step = 1;
			pObject->AddLog(1, pObject->autobr->automata + 1);
		}
	}

	//  
	pObject->EnableControls(true);

	if (pObject->autobr->finish) 
	{
		char s[128];
		sprintf(s, " ! (%d ())", pObject->autobr->counter);
		pObject->MessageBox(s, "", MB_OK);
		pObject->AddLog(5);
	}
    AfxEndThread(0);
	return 0;
}

UINT StepBigProc(LPVOID pParam)
/*
	   
*/
{
	CBrick0_1bDlg* pObject = (CBrick0_1bDlg*)pParam;

	//  
	pObject->EnableControls(false);

	//  
	list <action> act;
	int automata = pObject->autobr->automata;

	if (!pObject->autobr->finish)
	{
		while (pObject->autobr->automata == automata)
		{
			act = pObject->autobr->NextStep();

			if (!act.empty())
			{
				pObject->AddLog(2, pObject->step);
				
				for (list <action> :: iterator i = act.begin(); i != act.end(); i++)
				{
					pObject->br.Rotate(i->side, i->direct);
					pObject->AddLog(i->side, i->direct);
					pObject->Invalidate(0);
					Sleep(pObject->delay);
				}
				
				pObject->step++;
				pObject->AddLog("\r\n");
			}
		}
		pObject->step = 1;
	}

	//  
	pObject->EnableControls(true);

	// 
	if (pObject->autobr->finish) {
		char s[128];
		sprintf(s, " ! (%d ())", pObject->autobr->counter);
		pObject->MessageBox(s, "", MB_OK);
		pObject->AddLog(5);
	} else
		pObject->AddLog(1, pObject->autobr->automata + 1);
	AfxEndThread(0);
	return 0;
}

UINT BuildProc(LPVOID pParam)
/*
	  
*/
{
	CBrick0_1bDlg* pObject = (CBrick0_1bDlg*)pParam;

	//  
	list <action> act;

	//  
	pObject->EnableControls(false, true);

	//  
	while (!pObject->autobr->finish)
	{
		while (pObject->pause);

		if (pObject->is_first)
		{
			pObject->AddLog(1, 1);
			pObject->is_first = false;
		}

		int automata = pObject->autobr->automata;
		act = pObject->autobr->NextStep();

		if (!act.empty())
		{
			pObject->AddLog(2, pObject->step);

			for (list <action> :: iterator i = act.begin(); i != act.end(); i++)
			{
				pObject->br.Rotate(i->side, i->direct);
				pObject->AddLog(i->side, i->direct);
				pObject->Invalidate(0);
				Sleep(pObject->delay);
			}
			
			pObject->step++;
			pObject->AddLog("\r\n");
		}

		if (pObject->autobr->automata != automata)
		{
			if (pObject->autobr->automata < 7)
				pObject->AddLog(1, pObject->autobr->automata + 1);
			pObject->step = 1;
		}
	}

	//  
	pObject->EnableControls(true, true);

	// 
	char s[128];
	sprintf(s, " ! (%d ())", pObject->autobr->counter);
	pObject->MessageBox(s, "", MB_OK);
	pObject->AddLog(5);
    AfxEndThread(0);
	return 0;
}

UINT RandomProc(LPVOID pParam)
/*
	  
*/
{
	CBrick0_1bDlg* pObject = (CBrick0_1bDlg*)pParam;

	//  
	pObject->EnableControls(false);

	//  
	srand((unsigned)time(NULL));

	int iter = rand() % 20 + 30;
	for (int i = 0; i < iter; i++)
	{
		int side = rand() % 6 + 1;
		bool direct;
		if (rand() % 2)
			direct = true;
		else
			direct = false;

		pObject->br.Rotate(side, direct);
		pObject->Invalidate(0);
		Sleep(pObject->delay / 20);
	}
	pObject->AddLog(".\r\n");

	//  
	pObject->EnableControls(true);

	// 
	AfxEndThread(0);
    return 0;
}


// ""
void CBrick0_1bDlg::OnFileNew()
{
	autobr->Reset();
	is_first = true;
	br.Init();
	editLog.SetWindowText("");
	
	DrawScene();

	AddLog(".\r\n");
}

void CBrick0_1bDlg::OnFileOpen()
/*
            .
     OnFileSave()
*/
{
	CString sPathName;
	CFileDialog *dlg = new CFileDialog(true, "brk", ".brk", OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, 
							"Brick Files (*.brk)|*.brk||", this, NULL);
	if(dlg->DoModal() == IDOK)
	{
		sPathName = dlg->GetPathName();
		CFile file;
		
		autobr->Reset();
		is_first = true;
		br.Init();

		try
		{
			file.Open(sPathName, CFile::modeRead , NULL);
			for(int i = 0; i < 3; i++)
			{
				for(int j = 0; j < 3; j++)
				{
					for(int k = 0; k < 3; k++)
					{
						char * ch = new char;
						for(int h = 0; h < 6; h++)
						{	
							file.Read(ch,1);
							br.SetColor(i, j, k, h, atoi(ch));						
						}						
					}
				}
			}
			DrawScene();

			AddLog(" .\r\n");
		}
		catch(CFileException *e)
		{
			e->Delete();
			AfxMessageBox("  .", MB_OK | MB_ICONERROR,  NULL);
		}

	}
	delete dlg;
}

void CBrick0_1bDlg::OnFileSave()
/*
	        
	   ".brk"
	 :       
*/
{
	CString sPathName;
	CFileDialog *dlg = new CFileDialog(false, "brk", ".brk", OFN_OVERWRITEPROMPT , 
							"Brick Files (*.brk)|*.brk||", this, NULL);
	if(dlg->DoModal() == IDOK)
	{
		sPathName = dlg->GetPathName();
		CFile file;
		try
		{
			file.Open(sPathName,CFile::modeCreate | CFile::modeWrite, NULL);
			for(int i = 0; i < 3; i++)
			{
				for(int j = 0; j < 3; j++)
				{
					for(int k = 0; k < 3; k++)
					{
						char *ch = new char;
						for(int h = 0; h < 6; h++)
						{
							itoa(br.GetColor(i, j, k, h),ch,10);
							file.Write(ch, 1);
						}						
					}
				}
			}
		}
		catch(CFileException *e)
		{
			e->Delete();
			AfxMessageBox("  .", MB_OK | MB_ICONERROR,  NULL);
		}
	}
	delete dlg;

}

void CBrick0_1bDlg::OnFileExit()
/*
	
*/
{
	exit(0);
}

void CBrick0_1bDlg::OnStapsNext()
/*
	 
*/
{
	OnNextStepBtnClick();
}

void CBrick0_1bDlg::OnStapsMultinext()
/*
	 
*/
{
	OnNextMultistepBtnClick();
}

void CBrick0_1bDlg::OnStapsAuto()
/*
	
*/
{
	OnBnClickedAuto();
}

void CBrick0_1bDlg::OnDelay100ms()
/*
	 
*/
{
	CMenu* menu = (CMenu*)GetMenu();
	menu->CheckMenuItem(ID_DELAY_100MS, MF_CHECKED | MF_BYCOMMAND);
	menu->CheckMenuItem(ID_DELAY_200MS, MF_UNCHECKED | MF_BYCOMMAND);	
	menu->CheckMenuItem(ID_DELAY_300MS, MF_UNCHECKED | MF_BYCOMMAND);	
	menu->CheckMenuItem(ID_DELAY_400MS, MF_UNCHECKED | MF_BYCOMMAND);	
	menu->CheckMenuItem(ID_DELAY_500MS, MF_UNCHECKED | MF_BYCOMMAND);	

	delay = 100;
}

void CBrick0_1bDlg::OnDelay200ms()
/*
	 
*/
{
	CMenu* menu = (CMenu*)GetMenu();
	menu->CheckMenuItem(ID_DELAY_100MS, MF_UNCHECKED | MF_BYCOMMAND);
	menu->CheckMenuItem(ID_DELAY_200MS, MF_CHECKED | MF_BYCOMMAND);	
	menu->CheckMenuItem(ID_DELAY_300MS, MF_UNCHECKED | MF_BYCOMMAND);	
	menu->CheckMenuItem(ID_DELAY_400MS, MF_UNCHECKED | MF_BYCOMMAND);	
	menu->CheckMenuItem(ID_DELAY_500MS, MF_UNCHECKED | MF_BYCOMMAND);	

	delay = 200;
}

void CBrick0_1bDlg::OnDelay300ms()
/*
	 
*/
{
	CMenu* menu = (CMenu*)GetMenu();
	menu->CheckMenuItem(ID_DELAY_100MS, MF_UNCHECKED | MF_BYCOMMAND);
	menu->CheckMenuItem(ID_DELAY_200MS, MF_UNCHECKED | MF_BYCOMMAND);	
	menu->CheckMenuItem(ID_DELAY_300MS, MF_CHECKED | MF_BYCOMMAND);	
	menu->CheckMenuItem(ID_DELAY_400MS, MF_UNCHECKED | MF_BYCOMMAND);	
	menu->CheckMenuItem(ID_DELAY_500MS, MF_UNCHECKED | MF_BYCOMMAND);	

	delay = 300;
}

void CBrick0_1bDlg::OnDelay400ms()
/*
	 
*/
{
	CMenu* menu = (CMenu*)GetMenu();
	menu->CheckMenuItem(ID_DELAY_100MS, MF_UNCHECKED | MF_BYCOMMAND);
	menu->CheckMenuItem(ID_DELAY_200MS, MF_UNCHECKED | MF_BYCOMMAND);	
	menu->CheckMenuItem(ID_DELAY_300MS, MF_UNCHECKED | MF_BYCOMMAND);	
	menu->CheckMenuItem(ID_DELAY_400MS, MF_CHECKED | MF_BYCOMMAND);	
	menu->CheckMenuItem(ID_DELAY_500MS, MF_UNCHECKED | MF_BYCOMMAND);	

	delay = 400;
}

void CBrick0_1bDlg::OnDelay500ms()
/*
	 
*/
{
	CMenu* menu = (CMenu*)GetMenu();
	menu->CheckMenuItem(ID_DELAY_100MS, MF_UNCHECKED | MF_BYCOMMAND);
	menu->CheckMenuItem(ID_DELAY_200MS, MF_UNCHECKED | MF_BYCOMMAND);	
	menu->CheckMenuItem(ID_DELAY_300MS, MF_UNCHECKED | MF_BYCOMMAND);	
	menu->CheckMenuItem(ID_DELAY_400MS, MF_UNCHECKED | MF_BYCOMMAND);	
	menu->CheckMenuItem(ID_DELAY_500MS, MF_CHECKED | MF_BYCOMMAND);	

	delay = 500;
}

void CBrick0_1bDlg::OnViewLogPanel()
/*
	/  
*/
{
	CMenu* menu = (CMenu*)GetMenu();
	UINT flags;
	flags = menu->GetMenuState(ID_VIEW_LOGPANEL, MF_BYCOMMAND);
	
	if (flags & MF_CHECKED) {
		menu->CheckMenuItem(ID_VIEW_LOGPANEL, MF_UNCHECKED | MF_BYCOMMAND);

		editLog.ShowWindow(SW_HIDE);
	} else {
		menu->CheckMenuItem(ID_VIEW_LOGPANEL, MF_CHECKED | MF_BYCOMMAND);

		editLog.ShowWindow(SW_SHOW);
	}
}

void CBrick0_1bDlg::OnAbout()
/*
	 "About..."
*/
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}

//  
void CBrick0_1bDlg::AddLog(int side, bool dir)
/*
	   
*/
{
	CString str;
	editLog.GetWindowText(str);

	switch (side)
	{
	case 1:							// 
		if (dir) 
			str += "1 ";
		else
			str += "1' ";
		break;
	case 2:							// 
		if (dir) 
			str += "2 ";
		else
			str += "2' ";
		break;
	case 3:							// 
		if (dir) 
			str += "3 ";
		else
			str += "3' ";
		break;
	case 4:							// 
		if (dir) 
			str += "4 ";
		else
			str += "4' ";

		break;
	case 5:							// 
		if (dir) 
			str += "5 ";
		else
			str += "5' ";
		break;
	case 6:							// 
		if (dir) 
			str += "6 ";
		else
			str += "6' ";
		break;
	}

	editLog.SetWindowText(str);
}

void CBrick0_1bDlg::AddLog(CString newStr)
/*
	   
*/
{
	CString str;
	editLog.GetWindowText(str);

	str += newStr;
	editLog.SetWindowText(str);
}

void CBrick0_1bDlg::AddLog(int command, int number)
/*
	     
*/
{
	char temp[16];
	CString str;
	editLog.GetWindowText(str);

	switch (command)
	{
	case 1:
		str += " #";
		str += itoa(number, temp, 10);
		str += ":\r\n";
		break;
	case 2:
		str += " ";
		str += itoa(number, temp, 10);
		str += ": ";
		break;
	case 3:
		str += ".\r\n";
		break;
	case 4:
		str += ".\r\n";
		break;
	case 5:
		str += " : ";
		str += itoa(autobr->counter, temp, 10);
		str += " ().\r\n";
	}

	editLog.SetWindowText(str);
}

void CBrick0_1bDlg::EnableControls(bool enable, bool is_auto)
{
	CButton* st = (CButton*)GetDlgItem(IDC_STAPS_NEXT);
	CButton* mu = (CButton*)GetDlgItem(IDC_STAPS_MULTINEXT);
	CButton* au = (CButton*)GetDlgItem(IDC_AUTO);
	CButton* pa = (CButton*)GetDlgItem(IDC_PAUSE);
	CButton* mi = (CButton*)GetDlgItem(IDC_MIXUP);
	CMenu* menu = GetMenu();
	CMenu* submenu;

	if (!enable) {
		st->EnableWindow(false);
		mu->EnableWindow(false);
		au->EnableWindow(false);
		if (!is_auto) pa->EnableWindow(false);
		mi->EnableWindow(false);

		submenu = menu->GetSubMenu(0);
		submenu->EnableMenuItem(ID_FILE_NEW, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
		submenu->EnableMenuItem(ID_FILE_OPEN, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
		submenu->EnableMenuItem(ID_FILE_SAVE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
		submenu = menu->GetSubMenu(1);
		submenu->EnableMenuItem(ID_STAPS_NEXT, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
		submenu->EnableMenuItem(ID_STAPS_MULTINEXT, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	} else {
		st->EnableWindow(true);
		mu->EnableWindow(true);
		au->EnableWindow(true);
		if (!is_auto) pa->EnableWindow(true);
		mi->EnableWindow(true);

		submenu = menu->GetSubMenu(0);
		submenu->EnableMenuItem(ID_FILE_NEW, MF_BYCOMMAND | MF_ENABLED);
		submenu->EnableMenuItem(ID_FILE_OPEN, MF_BYCOMMAND | MF_ENABLED);
		submenu->EnableMenuItem(ID_FILE_SAVE, MF_BYCOMMAND | MF_ENABLED);
		submenu = menu->GetSubMenu(1);
		submenu->EnableMenuItem(ID_STAPS_NEXT, MF_BYCOMMAND | MF_ENABLED);
		submenu->EnableMenuItem(ID_STAPS_MULTINEXT, MF_BYCOMMAND | MF_ENABLED);
	}
}