// Brick0_1bDlg.h:   CBrick0_1bDlg
//
//////////////////////////////////////////////////////////////////////

#pragma once

#include <windows.h>                      //    Windows
#include <gl\gl.h>                        //    OpenGL32 
#include <gl\glu.h>                       //    GLu32 
#include <gl\glaux.h>                     //    GLaux 
#include "BigBrick.h"
#include "AutoBrick.h"
#include "afxwin.h"

class CBrick0_1bDlg : public CDialog
{
public:
	CBrick0_1bDlg(CWnd* pParent = NULL);	// standard constructor

	enum { IDD = IDD_BRICK0_1B_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);


protected:
	HICON m_hIcon;

	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnTimer(UINT nIDEvent);
	DECLARE_MESSAGE_MAP()

// 
private:
	CDC* 	pDC;
	GLfloat nXangle;
	GLfloat nYangle;
	GLfloat nZangle;

public:
	CBigBrick 	br;					//  
	CAutoBrick* autobr;             //   CAutoBrick
	bool 		pause;              //  
	int 		step;               //  
	int 		delay;              // 
	bool 		is_first;           //    

	GLvoid 	InitGL();
    bool 	bSetupPixelFormat();
	void 	DrawScene();

	void 	AddLog(int, bool);      //     
	void 	AddLog(CString);		//   
	void 	AddLog(int, int number = 0);				//     
	void	EnableControls(bool, bool is_auto = false);	// / 

public:
	afx_msg void OnBnClickedRight();
	afx_msg void OnBnClickedYPos();
	afx_msg void OnBnClickedXPos();
	afx_msg void OnBnClickedXNeg();
	afx_msg void OnNextStepBtnClick();
	afx_msg void OnBnClickedAuto();
	afx_msg void OnFileOpen();
	afx_msg void OnFileSave();
	afx_msg void OnBnClickedMixUp();
	afx_msg void OnBnClickedPause();
	afx_msg void OnNextMultistepBtnClick();
	afx_msg void OnFileNew();
private:
	//   
	CEdit editLog;
public:
	afx_msg void OnStapsNext();
	afx_msg void OnStapsMultinext();
	afx_msg void OnFileExit();
	afx_msg void OnViewLogPanel();
	afx_msg void OnStapsAuto();
	afx_msg void OnDelay100ms();
	afx_msg void OnDelay200ms();
	afx_msg void OnDelay300ms();
	afx_msg void OnDelay400ms();
	afx_msg void OnDelay500ms();
	afx_msg void OnAbout();
};
